// gp_demoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "resource.h"
#include "gp_demo.h"
#include "gp_demoDlg.h"
#include ".\gp_demodlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cgp_demoDlg Dialogfeld

const SL_DATA Cgp_demoDlg::m_SLData[GP_NUMBER_OF_SINGLE_LINE_FIELDS] = {
	{  20,  20, D3DCOLOR_ARGB(200,   0,   0,   0), false, 12, false, 0 },
	{  20,  40, D3DCOLOR_ARGB(200, 255,   0,   0), false, 16, true,  1 },
	{  20,  60, D3DCOLOR_ARGB(200,   0, 255,   0), false, 20, false, 0 },
	{  20,  90, D3DCOLOR_ARGB(200,   0,   0, 255), false, 24, true,  1 },
	{  20, 120, D3DCOLOR_ARGB(200,   0, 255, 255), false, 32, false, 0 },
	{ 320,  20, D3DCOLOR_ARGB(200, 255, 255, 255), true,  12, true,  1 },
	{ 320,  40, D3DCOLOR_ARGB(200, 255,   0,   0), true,  16, false, 0 },
	{ 320,  60, D3DCOLOR_ARGB(200,   0, 255,   0), true,  20, true,  1 },
	{ 320,  90, D3DCOLOR_ARGB(200,   0,   0, 255), true,  24, false, 0 },
	{ 320, 120, D3DCOLOR_ARGB(200,   0, 255, 255), true,  32, true,  1 }
};

const ML_DATA Cgp_demoDlg::m_MLData[GP_NUMBER_OF_MULTI_LINES_FIELDS] = {
	{  20, 200, D3DCOLOR_ARGB(150, 255,   0,   0), false, 24, true,  0, 100, 200 },
	{ 140, 200, D3DCOLOR_ARGB(150,   0, 255,   0), true,  24, true,  0, 100, 100 },
	{ 260, 200, D3DCOLOR_ARGB(150,   0,   0, 255), false, 24, false, 0, 100, 200 },
	{ 380, 200, D3DCOLOR_ARGB(150, 255,   0, 255), true,  24, false, 0, 100, 100 },
	{ 520, 200, D3DCOLOR_ARGB(150, 255, 255, 255), false, 24, false, 0, 100, 200 }
};

Cgp_demoDlg::Cgp_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cgp_demoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_hGPDll = NULL;

	m_sSLText = L"This is a Single Line";
	m_sMLText = L"This\r\nis a\r\nmulti-line text.";
}

void Cgp_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SCREENSIZEEDIT, m_sScreenSizeText);
	DDX_Text(pDX, IDC_INGAMETEXT_SL_EDIT, m_sSLText);
	DDX_Text(pDX, IDC_INGAMETEXT_ML_EDIT, m_sMLText);
}

BEGIN_MESSAGE_MAP(Cgp_demoDlg, CDialog)
    ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &Cgp_demoDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_SCREENSIZEBUTTON, &Cgp_demoDlg::OnBnClickedScreensizebutton)
	ON_BN_CLICKED(IDC_TOGGLESHOWFPSBUTTON, &Cgp_demoDlg::OnBnClickedToggleshowfpsbutton)
	ON_BN_CLICKED(IDC_TOGGLE_SL1_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl1Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL2_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl2Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL3_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl3Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL4_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl4Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL5_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl5Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML1_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl1Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML2_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl2Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML3_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl3Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML4_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl4Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML5_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl5Button)
	ON_BN_CLICKED(IDC_SET_PIC_BUTTON3, &Cgp_demoDlg::OnBnClickedSetPicButton3)
	ON_BN_CLICKED(IDC_SET_PIC_BUTTON4, &Cgp_demoDlg::OnBnClickedSetPicButton4)
	ON_BN_CLICKED(IDC_SET_PIC_BUTTON5, &Cgp_demoDlg::OnBnClickedSetPicButton5)
	ON_BN_CLICKED(IDC_TOGGLE_SL6_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl6Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL7_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl7Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL8_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl8Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL9_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl9Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL10_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl10Button)
END_MESSAGE_MAP()


// Cgp_demoDlg Meldungshandler

BOOL Cgp_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

 	// GPCOMMS.DLL
#if defined _M_IX86
	m_hGPDll = LoadLibrary(L"gpcomms.dll"); 
#else
	m_hGPDll = LoadLibrary(L"gpcomms_64.dll"); 
#endif

    if (!m_hGPDll) 
    {
#if defined _M_IX86
		AfxMessageBox(L"GPCOMMS.DLL not found !", MB_ICONSTOP);
#elif defined _M_X64
		AfxMessageBox(L"GPCOMMS_64.DLL not found !", MB_ICONSTOP);
#endif
        ::PostQuitMessage(0);
        return(true);
    }

    GPSL_SetTextLineData		  = (GPSL_SETTEXTLINEDATA) GetProcAddress(m_hGPDll, "GPSL_SetTextLineData"); 
    GPSL_ShowText				  = (GPSL_SHOWTEXT) GetProcAddress(m_hGPDll, "GPSL_ShowText"); 
    GPML_SetTextMultilineData	  = (GPML_SETTEXTMULTILINEDATA) GetProcAddress(m_hGPDll, "GPML_SetTextMultilineData"); 
    GPML_ShowText				  = (GPML_SHOWTEXT) GetProcAddress(m_hGPDll, "GPML_ShowText"); 
    GPPIC_LoadNewPicture		  = (GPPIC_LOADNEWPICTURE) GetProcAddress(m_hGPDll, "GPPIC_LoadNewPicture");
    GPPIC_ShowPicturePos		  = (GPPIC_SHOWPICTUREPOS) GetProcAddress(m_hGPDll, "GPPIC_ShowPicturePos");
	GPSI_GetScreenSize			  = (GPSI_GETSCREENSIZE) GetProcAddress(m_hGPDll, "GPSI_GetScreenSize");
	GPSI_ShowFPS				  = (GPSI_SHOWFPS) GetProcAddress(m_hGPDll, "GPSI_ShowFPS");
	GPSS_MakeScreenshot			  = (GPSS_MAKESCREENSHOT) GetProcAddress(m_hGPDll, "GPSS_MakeScreenshot");
	GPPICI_LoadNewInternalPicture = (GPPICI_LOADNEWINTERNALPICTURE)GetProcAddress(m_hGPDll, "GPPICI_LoadNewInternalPicture");
	GPPICI_ShowInternalPicturePos = (GPPICI_SHOWINTERNALPICTUREPOS)GetProcAddress(m_hGPDll, "GPPICI_ShowInternalPicturePos");

	if (!GPSL_SetTextLineData || !GPSL_ShowText        || !GPML_SetTextMultilineData ||
		!GPML_ShowText        || !GPPIC_LoadNewPicture || !GPPIC_ShowPicturePos      ||
		!GPSI_GetScreenSize   || !GPSI_ShowFPS         || !GPSS_MakeScreenshot       ||
		!GPPICI_LoadNewInternalPicture                 || !GPPICI_ShowInternalPicturePos)
    {
        AfxMessageBox(L"GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

	UpdateData(false);

    return(true);  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void Cgp_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void Cgp_demoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR Cgp_demoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL Cgp_demoDlg::DestroyWindow()
{
	DB(L"Cgp_demoDlg::DestroyWindow called.\r\n");
    return CDialog::DestroyWindow();
}

void Cgp_demoDlg::CleanUp()
{
	DB(L"Cgp_demoDlg::CleanUp called.\r\n");

    // the communications wrapper dll
    if (m_hGPDll) 
    {
        FreeLibrary(m_hGPDll);
        m_hGPDll = NULL;
    }    
}

void Cgp_demoDlg::OnBnClickedOk()
{
	CleanUp();
	OnOK();
}

void Cgp_demoDlg::OnCancel()
{
	CleanUp();
	CDialog::OnCancel();
}

void Cgp_demoDlg::OnBnClickedScreensizebutton()
{
	int x, y;
	GPSI_GetScreenSize(&x, &y);
	UpdateData(true);
	m_sScreenSizeText.Format(L"%i x %i", x, y);
	UpdateData(false);
}

void Cgp_demoDlg::OnBnClickedToggleshowfpsbutton()
{
	static bool bShowIt = false;
	bShowIt = !bShowIt;
	GPSI_ShowFPS(bShowIt);
}

void Cgp_demoDlg::ShowSingleLine(BYTE i)
{
	UpdateData(true);
	GPSL_SetTextLineData(i, m_SLData[i].wTextPosX, m_SLData[i].wTextPosY, (LPCWSTR)m_sSLText, m_SLData[i].dwTextColor, m_SLData[i].bBlackBackground, m_SLData[i].cSize, m_SLData[i].bTextBold, m_SLData[i].cFontFamily);
	GPSL_ShowText(i, true);
}

void Cgp_demoDlg::OnBnClickedToggleSl1Button()
{
	ShowSingleLine(0);
}

void Cgp_demoDlg::OnBnClickedToggleSl2Button()
{
	ShowSingleLine(1);
}

void Cgp_demoDlg::OnBnClickedToggleSl3Button()
{
	ShowSingleLine(2);
}

void Cgp_demoDlg::OnBnClickedToggleSl4Button()
{
	ShowSingleLine(3);
}

void Cgp_demoDlg::OnBnClickedToggleSl5Button()
{
	ShowSingleLine(4);
}

void Cgp_demoDlg::OnBnClickedToggleSl6Button()
{
	ShowSingleLine(5);
}


void Cgp_demoDlg::OnBnClickedToggleSl7Button()
{
	ShowSingleLine(6);
}


void Cgp_demoDlg::OnBnClickedToggleSl8Button()
{
	ShowSingleLine(7);
}


void Cgp_demoDlg::OnBnClickedToggleSl9Button()
{
	ShowSingleLine(8);
}


void Cgp_demoDlg::OnBnClickedToggleSl10Button()
{
	ShowSingleLine(9);
}

void Cgp_demoDlg::ShowMultiLine(BYTE i)
{
	UpdateData(true);
	GPML_SetTextMultilineData(i, m_MLData[i].wTextPosX, m_MLData[i].wTextPosY, (LPCWSTR)m_sMLText, m_MLData[i].dwTextColor, m_MLData[i].bBlackBackground, m_MLData[i].cSize, m_MLData[i].bTextBold, m_MLData[i].wSizeX, m_MLData[i].wSizeY, m_MLData[i].cFontFamily);
	GPML_ShowText(i, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl1Button()
{
	ShowMultiLine(0);
}

void Cgp_demoDlg::OnBnClickedToggleMl2Button()
{
	ShowMultiLine(1);
}

void Cgp_demoDlg::OnBnClickedToggleMl3Button()
{
	ShowMultiLine(2);
}

void Cgp_demoDlg::OnBnClickedToggleMl4Button()
{
	ShowMultiLine(3);
}

void Cgp_demoDlg::OnBnClickedToggleMl5Button()
{
	ShowMultiLine(4);
}

void Cgp_demoDlg::OnBnClickedSetPicButton3()
{
	CString sLoadPath;
	GetModuleFileName(NULL, CStrBuf(sLoadPath, MAX_PATH), MAX_PATH);
	PathRemoveFileSpec(CStrBuf(sLoadPath, MAX_PATH));
	sLoadPath.Append(L"\\testimage.jpg");
	
	GPPIC_LoadNewPicture((LPCWSTR)sLoadPath);
	GPPIC_ShowPicturePos(true, 400, 500);
}

void Cgp_demoDlg::OnBnClickedSetPicButton4()
{
	CString sSavePath;
	GetModuleFileName(NULL, CStrBuf(sSavePath, MAX_PATH), MAX_PATH);
	PathRemoveFileSpec(CStrBuf(sSavePath, MAX_PATH));
	sSavePath.Append(L"\\screenshot.jpg");

	GPSS_MakeScreenshot(true, (LPCWSTR)sSavePath);
}

void Cgp_demoDlg::OnBnClickedSetPicButton5()
{
	HRSRC picResource = ::FindResource(NULL, MAKEINTRESOURCE(IDB_BITMAP1), RT_RCDATA);
	HGLOBAL picResourceData = ::LoadResource(NULL, picResource);
	BYTE* pPicBinaryData = (BYTE*) ::LockResource(picResourceData);

	GPPICI_LoadNewInternalPicture(pPicBinaryData, SizeofResource(NULL, picResource));
	GPPICI_ShowInternalPicturePos(true, 300, 400);
}



