// gp_demoDlg.h : Headerdatei
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"

struct SL_DATA
{
	WORD wTextPosX;
	WORD wTextPosY;
	DWORD dwTextColor;
	bool bBlackBackground;
	BYTE cSize;
	bool bTextBold;
	BYTE cFontFamily;
};

struct ML_DATA
{
	WORD wTextPosX;
	WORD wTextPosY;
	DWORD dwTextColor;
	bool bBlackBackground;
	BYTE cSize;
	bool bTextBold;
	BYTE cFontFamily;
	WORD wSizeX;
	WORD wSizeY;
};

// Cgp_demoDlg Dialogfeld
class Cgp_demoDlg : public CDialog
{

	// Konstruktion
public:
	HINSTANCE m_hGPDll;
	GPSL_SETTEXTLINEDATA		GPSL_SetTextLineData;
	GPSL_SHOWTEXT				GPSL_ShowText;
	GPML_SETTEXTMULTILINEDATA	GPML_SetTextMultilineData;
	GPML_SHOWTEXT				GPML_ShowText;
	GPPIC_LOADNEWPICTURE		GPPIC_LoadNewPicture;
	GPPIC_SHOWPICTUREPOS		GPPIC_ShowPicturePos;
	GPSI_GETSCREENSIZE			GPSI_GetScreenSize;
	GPSI_SHOWFPS				GPSI_ShowFPS;
	GPSS_MAKESCREENSHOT			GPSS_MakeScreenshot;
	GPPICI_LOADNEWINTERNALPICTURE	GPPICI_LoadNewInternalPicture;
	GPPICI_SHOWINTERNALPICTUREPOS	GPPICI_ShowInternalPicturePos;

	Cgp_demoDlg(CWnd* pParent = NULL);	// Standardkonstruktor
	virtual BOOL DestroyWindow();
	enum { IDD = IDD_GP_DEMO_DIALOG };

	afx_msg void OnBnClickedScreensizebutton();
	afx_msg void OnBnClickedToggleshowfpsbutton();
	afx_msg void OnBnClickedToggleSl1Button();
	afx_msg void OnBnClickedToggleSl2Button();
	afx_msg void OnBnClickedToggleSl3Button();
	afx_msg void OnBnClickedToggleSl4Button();
	afx_msg void OnBnClickedToggleSl5Button();
	afx_msg void OnBnClickedToggleMl1Button();
	afx_msg void OnBnClickedToggleMl2Button();
	afx_msg void OnBnClickedToggleMl3Button();
	afx_msg void OnBnClickedToggleMl4Button();
	afx_msg void OnBnClickedToggleMl5Button();
	afx_msg void OnBnClickedToggleSl6Button();
	afx_msg void OnBnClickedToggleSl7Button();
	afx_msg void OnBnClickedToggleSl8Button();
	afx_msg void OnBnClickedToggleSl9Button();
	afx_msg void OnBnClickedToggleSl10Button();
	afx_msg void OnBnClickedSetPicButton3();
	afx_msg void OnBnClickedSetPicButton4();
	afx_msg void OnBnClickedSetPicButton5();

	CString m_sSLText;
	CString m_sMLText;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	DECLARE_MESSAGE_MAP()
	HICON m_hIcon;
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();

private:
	afx_msg void OnPaint();
	afx_msg void OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult);
	void Cgp_demoDlg::CleanUp();
	void ShowSingleLine(BYTE i);
	void ShowMultiLine(BYTE i);
	afx_msg void OnBnClickedOk();
	CString m_sScreenSizeText;

	static const SL_DATA m_SLData[GP_NUMBER_OF_SINGLE_LINE_FIELDS];
	static const ML_DATA m_MLData[GP_NUMBER_OF_MULTI_LINES_FIELDS];
};